{- 

HOpenGL Tutorial
http://www.cin.ufpe.br/~hopengl/
Copyright (C) 2002  Andre Furtado <awbf@cin.ufpe.br>

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

This is a HOpenGL example.

---------------------------------------------------------------
Command list:

q - increases the rotation angle
w - decreases the rotation angle
e - rotation angle == 0
Home - moves to inside
End - moves to outside
UpArrow - moves up
DownArrow - moves down
LeftArrow - moves left
RightArrow - moves right
Space Bar - enters full screen mode
Enter - leaves full screen mode
Esc - quit

-}


import GLUT
import GL
import Awbfbmp
import Monad(liftM)
import IOExts
foreign import shutdownHaskellAndExit :: Int -> IO ()

cons :: Float
cons = 1.0

idle :: TextureName -> (IORef GLfloat,IORef GLfloat,IORef GLfloat,IORef GLfloat,IORef GLfloat) -> IdleAction
idle texName (speed,angle,tx,ty,tz) = do
		clear [ ColorBufferBit ]
		x <- readIORef tx
		y <- readIORef ty
		z <- readIORef tz
		a <- readIORef angle
		s <- readIORef speed
		
		loadIdentity
		color (Color3 1.0 0.0 (0.0 :: GLfloat))
		translate (Vector3 (x - 15.0) (y + 15.0) z)
		rotate a (Vector3 1.0 0.0 0.0)
		drawTexCube texName
		
		loadIdentity
		color (Color3 0.0 1.0 (0.0 :: GLfloat))
		translate (Vector3 (x + 15.0) (y + 15.0) z)
		rotate a (Vector3 0.0 1.0 0.0)
		drawTexCube texName
		
		loadIdentity
		color (Color3 0.0 0.0 (1.0 :: GLfloat))
		translate (Vector3 (x - 15.0) (y - 15.0) z)
		rotate a (Vector3 0.0 0.0 1.0)
		drawTexCube texName
		
		loadIdentity
		color (Color3 1.0 1.0 (0.0 :: GLfloat))
		translate (Vector3 (x + 15.0) (y - 15.0) z)
		rotate a (Vector3 1.0 1.0 1.0)
		drawTexCube texName
		
		loadIdentity
		writeIORef angle (a + s)
		flush
		swapBuffers		

drawTexCube :: TextureName -> IO ()
drawTexCube texName = do
		
		enable Texture2d'
		bindTexture Texture2d texName
				
		let texCoord2 :: GLfloat -> GLfloat -> IO ()
       		    texCoord2 x y = texCoord (TexCoord2 x y)
       		    vertex3 :: GLfloat -> GLfloat -> GLfloat -> IO ()
       		    vertex3 x y z = vertex (Vertex3 x y z)
		
		beginEnd Quads $ do
      			texCoord2 0.0 0.0;  vertex3 (-5.0)      5.0   (-5.0)
      			texCoord2 0.0 1.0;  vertex3   5.0       5.0   (-5.0)
      			texCoord2 1.0 1.0;  vertex3   5.0     (-5.0)  (-5.0)
      			texCoord2 1.0 0.0;  vertex3 (-5.0)    (-5.0)  (-5.0)
      			
      			texCoord2 0.0 0.0;  vertex3 (-5.0)    (-5.0)   5.0
      			texCoord2 0.0 1.0;  vertex3   5.0     (-5.0)   5.0
      			texCoord2 1.0 1.0;  vertex3   5.0       5.0    5.0
      			texCoord2 1.0 0.0;  vertex3 (-5.0)      5.0    5.0
      			
      			texCoord2 0.0 0.0;  vertex3 (-5.0)   (-5.0)  (-5.0)
      			texCoord2 0.0 1.0;  vertex3 (-5.0)   (-5.0)    5.0
      			texCoord2 1.0 1.0;  vertex3 (-5.0)     5.0     5.0
      			texCoord2 1.0 0.0;  vertex3 (-5.0)     5.0   (-5.0)
      			
      			texCoord2 0.0 0.0;  vertex3 5.0     5.0     (-5.0)  
      			texCoord2 0.0 1.0;  vertex3 5.0     5.0       5.0
      			texCoord2 1.0 1.0;  vertex3 5.0   (-5.0)      5.0
      			texCoord2 1.0 0.0;  vertex3 5.0   (-5.0)    (-5.0)  
      			
      			texCoord2 0.0 0.0;  vertex3   5.0    (-5.0)   (-5.0)  
      			texCoord2 0.0 1.0;  vertex3   5.0    (-5.0)     5.0
      			texCoord2 1.0 1.0;  vertex3 (-5.0)   (-5.0)     5.0
      			texCoord2 1.0 0.0;  vertex3 (-5.0)   (-5.0)   (-5.0)  
      			
      			texCoord2 0.0 0.0;  vertex3 (-5.0)  5.0   (-5.0)  
      			texCoord2 0.0 1.0;  vertex3 (-5.0)  5.0     5.0
      			texCoord2 1.0 1.0;  vertex3   5.0   5.0     5.0
      			texCoord2 1.0 0.0;  vertex3   5.0   5.0   (-5.0)  
		      
		      
      		
   		disable Texture2d'
       		    
       		

drawCube :: IO ()
drawCube = beginEnd Quads $ do
      		color (Color3 1.0 0.0 (0.0 :: GLfloat))
      		vertex (Vertex3 (-5.0) 5.0 ((-5.0) :: GLfloat))
      		vertex (Vertex3 5.0 5.0 ((-5.0) :: GLfloat))
      		vertex (Vertex3 5.0 (-5.0) ((-5.0) :: GLfloat))
      		vertex (Vertex3 (-5.0) (-5.0) ((-5.0) :: GLfloat))
      		
      		color (Color3 1.0 0.0 (0.0 :: GLfloat))
      		vertex (Vertex3 (-5.0) (-5.0) (5.0 :: GLfloat))
      		vertex (Vertex3 5.0 (-5.0) (5.0 :: GLfloat))
      		vertex (Vertex3 5.0 5.0 (5.0 :: GLfloat))
      		vertex (Vertex3 (-5.0) 5.0 (5.0 :: GLfloat))
     		
      		color (Color3 0.0 1.0 (0.0 :: GLfloat))
      		vertex (Vertex3 (-5.0) (-5.0) ((-5.0) :: GLfloat))
      		vertex (Vertex3 (-5.0) (-5.0) (5.0 :: GLfloat))
      		vertex (Vertex3 (-5.0) 5.0 (5.0 :: GLfloat))
      		vertex (Vertex3 (-5.0) 5.0 ((-5.0) :: GLfloat))
      		
      		color (Color3 0.0 1.0 (0.0 :: GLfloat))
      		vertex (Vertex3 5.0 5.0 ((-5.0) :: GLfloat))
      		vertex (Vertex3 5.0 5.0 (5.0 :: GLfloat))
      		vertex (Vertex3 5.0 (-5.0) (5.0 :: GLfloat))
      		vertex (Vertex3 5.0 (-5.0) ((-5.0) :: GLfloat))
      		
      		color (Color3 0.0 0.0 (1.0 :: GLfloat))
      		vertex (Vertex3 5.0 (-5.0)  ((-5.0) :: GLfloat))
      		vertex (Vertex3 5.0 (-5.0) (5.0 :: GLfloat))
      		vertex (Vertex3 (-5.0) (-5.0)  (5.0 :: GLfloat))
      		vertex (Vertex3 (-5.0) (-5.0)  ((-5.0) :: GLfloat))
      		
      		color (Color3 0.0 0.0 (1.0 :: GLfloat))
      		vertex (Vertex3 (-5.0) 5.0  ((-5.0) :: GLfloat))
      		vertex (Vertex3 (-5.0) 5.0  (5.0 :: GLfloat))
      		vertex (Vertex3 5.0 5.0 (5.0 :: GLfloat))
      		vertex (Vertex3 5.0 5.0  ((-5.0) :: GLfloat))
      		
reshape :: ReshapeAction
reshape screenSize@(WindowSize w h) = do
   viewport (WindowPosition 0 0) screenSize
   matrixMode Projection
   loadIdentity
   let	near   = 1
	far    = 80
	fov    = 90
	ang    = (fov*pi)/(360 :: Double)
	top    = near / ( cos(ang) / sin(ang) )
	aspect = fromIntegral(w)/fromIntegral(h)
	right = top*aspect
   frustum (-right) right (-top) top near far
   matrixMode Modelview		
 
special :: (IORef GLfloat,IORef GLfloat,IORef GLfloat) -> SpecialAction
special (tx, ty, tz) KeyUp _ = do
				x <- readIORef tx
				y <- readIORef ty
				z <- readIORef tz
				writeIORef ty (y - cons)
				postRedisplay
				
special (tx, ty, tz) KeyDown _ = do
				x <- readIORef tx
				y <- readIORef ty
				z <- readIORef tz
				writeIORef ty (y + cons)
				postRedisplay
				
special (tx, ty, tz) KeyLeft _ = do
				x <- readIORef tx
				y <- readIORef ty
				z <- readIORef tz
				writeIORef tx (x + cons)
				postRedisplay
				
special (tx, ty, tz) KeyRight _ = do
				x <- readIORef tx
				y <- readIORef ty
				z <- readIORef tz
				writeIORef tx (x - cons)
				postRedisplay
				
special (tx, ty, tz) KeyHome _ = do
				x <- readIORef tx
				y <- readIORef ty
				z <- readIORef tz
				writeIORef tz (z + cons)
				postRedisplay
				
special (tx, ty, tz) KeyEnd _ = do
				x <- readIORef tx
				y <- readIORef ty
				z <- readIORef tz
				writeIORef tz (z - cons)
				postRedisplay						
special _ _  _ = return ()															
		
		
keyboard :: IORef GLfloat -> KeyboardAction
keyboard speed 'q'  _ = do
				s <- readIORef speed
				writeIORef speed (s + 0.5)
keyboard speed 'w'  _ = do
				s <- readIORef speed
				writeIORef speed (s - 0.5)
keyboard speed 'e'  _ = writeIORef speed 0.0				
keyboard _ '\27' _ = shutdownHaskellAndExit 1
keyboard _ '\r'  _ = reshapeWindow (WindowSize 600 600) >> positionWindow (WindowPosition 100 100)
keyboard _ '\32' _ = fullScreen
keyboard _ _ _ = return ()
		

myInit :: IO TextureName
myInit = do
		clearColor (Color4 0 0 0 0)
		clear[ColorBufferBit] 
		shadeModel GL.Smooth
		pixelStore Unpack (Alignment 4)
		matrixMode Projection
   		loadIdentity
		matrixMode Modelview
		loadIdentity
		enable CullFace
		(bmW,bmH,bmData) <- loadBitmap "tex1.bmp" Nothing
		texName <- liftM head (genTextures 1)
		bindTexture Texture2d texName
		texImage2D Texture2d 0 GL.Rgba' bmW bmH 0 bmData
		texParameter Texture2d (TextureFilters Nearest Nearest)
		return (texName)
						
main :: IO ()
main = do
	GLUT.init Nothing
	tx <- newIORef 0.0
	ty <- newIORef 0.0
	tz <- newIORef (-35.0)
	angle <- newIORef 0.0
	speed <- newIORef 1.0
	createWindow "Texturing (4 colors)" (return ()) [ GLUT.Double, GLUT.Rgb ]
                (Just (WindowPosition 100 100))
                (Just (WindowSize     600 600))
	texName <- myInit
   	keyboardFunc (Just (keyboard speed))
   	specialFunc (Just (special (tx, ty, tz)))
	reshapeFunc (Just reshape)
	idleFunc (Just (idle texName (speed,angle,tx, ty, tz)))
   	mainLoop